$(function(){
  
  //prevent default on all link clicks
  $('#ohw_widget_wrapper a').on('click', function(e){
    e.preventDefault();  
  });
  
  //set variables for first display and active header/type 
  
  var active_topic = 'water-sports';
  var active_type = 'news'; 
  
  //set use_height for height for main containers - subtract 102 for header/footer heights
  var use_height = $('#ohw_container').height() - 102;

  //set header_width for scrollable nav widths
  var header_width = $('#ohw_header').width();
  //setup variable for overall type nav width
  var type_width;
  
  //setup top level scrolling/width details                               
  var topic_nav_width = 0;
  var topic_nav_num = 0; 
  var type_nav_width = 0;
  var type_nav_num = 0;
  var scrolling;
  var scroll_start;
  var scroll_to_x;      
  var scroll_hovered;
                           

               
  //loop through and check each topic list item for full nav width
  $('.ohw_topic_list').each(function() {
    topic_nav_width += $(this).width();  
    topic_nav_num++;
  }); 
  
  //setup secondary navigation slider and sharing button option
  /**
  * reset type-width depending on if sharing button is active
  
  if(OHW.widget.widget_sharing.show_button == false){
    $('#ohw_type_share').hide();
    type_width = header_width;          
  } else {
    type_width = header_width - 75;
    $('#ohw_type_nav_box').css('width', type_width + 'px');
  }
  */
  
  
  /**
  * scroll function
  *                  
  
  function do_scroll(scroll_element, scroll_direction, scroll_max){
    //$(el).css('left', 
    scroll_start = $(scroll_element).css('left').replace('px', '');
    scroll_start = parseInt(scroll_start);
    //$('#test').append('--' + el.width() + '_' + current_x);
    if(scroll_direction == 'left'){
      if(scroll_start <= scroll_max){
        scroll_to_x = scroll_start + 2;
        $(scroll_element).css('left', scroll_to_x);
      }
    } else if(scroll_direction == 'right'){
      if(scroll_start > scroll_max){
        scroll_to_x = scroll_start - 2;
        $(scroll_element).css('left', scroll_to_x + 'px');
      }
    }
    if(!scroll_hovered){
      stop_scroll();
    }                                 
  }
  
  function start_scroll(scroll_element, scroll_direction, scroll_max) {
    window.clearInterval(scrolling);
    scrolling = window.setInterval(function(){ do_scroll(scroll_element, scroll_direction, scroll_max); }, 10);
  }
  
  function stop_scroll(){
    window.clearInterval(scrolling);
  }
      
  */                         
  
  /**
  * header sizing for scroll function
  
  //if full nav width is greater than header, setup scrolling options
  if(topic_nav_width > header_width) { 
    
    //minor calculation for inline-block spacing issues
    topic_nav_width += (topic_nav_num * 13) - topic_nav_num;
    $('#ohw_topic_nav').width(topic_nav_width);                                 
    //add left and right arrow sections and color them to the header link color
    $('#ohw_header').prepend('<div id="ohw_scroll_topic_nav_left" class="ohw_scroll_topic_nav">&nbsp;<<</div>');
    $('#ohw_header').append('<div id="ohw_scroll_topic_nav_right" class="ohw_scroll_topic_nav">&nbsp;>></div>');
    var use_topic_color = $('.ohw_topic_links').css('color');
    $('.ohw_scroll_topic_nav').css('color', use_topic_color);
    
    //make topic_nav width 50px less than full header to make room for adding boxes, set overflow to hidden and margin 0-auto for left/right float in center
    $('#ohw_topic_nav_box').css('width', $('#ohw_header').width() - 50).css('overflow', 'hidden').css('margin', '0 auto');
    //set max scrolling number (full width - full nav width) = negative number for max scrolling
    var max_topic_scroll = header_width - topic_nav_width;
    //header scroll variable for actual 'left' placement of topic_nav element
    //var topic_scroll = 0;
    
    $('#ohw_scroll_topic_nav_right').mousedown(function(){
      start_scroll($('#ohw_topic_nav'), 'right', max_topic_scroll);  
    }).mouseup(function() {
      stop_scroll();
    });
    
    $('#ohw_scroll_topic_nav_left').mousedown(function(){
      start_scroll($('#ohw_topic_nav'), 'left', 0);  
    }).mouseup(function() {
      stop_scroll();
    });
    
    //setup mouseover functions for funky behaviors 
    $('.ohw_scroll_topic_nav').mouseenter(function(){
      scroll_hovered = true;                       
    }).mouseleave(function(){
      scroll_hovered = false;                       
    });
  }
  */
  //end header sizing
  
  
  
  /**
  * size type nav for type scrolling
  * 
  
  function size_type_nav(){
    //revert to no-button sizing
    $('#ohw_type_nav_box').css('width', type_width + 'px').css('marginLeft', 0);
    $('#ohw_type_nav').css('left', 0);
    $('.ohw_scroll_type_nav').remove();
    //if new nav width is greater than type_width (type width calculated with 'sharing' button on/off)
    if(type_nav_width > type_width){                          
      $('#ohw_type_nav').width(type_nav_width);
      $('#ohw_type_nav_box').css('width', (type_width - 40) + 'px').css('marginLeft', '20px');
      $('#ohw_nav').prepend('<div id="ohw_scroll_type_nav_left" class="ohw_scroll_type_nav">&nbsp;<<</div>');
      $('#ohw_nav').append('<div id="ohw_scroll_type_nav_right" class="ohw_scroll_type_nav">&nbsp;>></div>');
      $('#ohw_scroll_type_nav_right').css('left', (type_width - 20) + 'px');
      var use_type_color = $('.ohw_type_links').css('color');
      $('.ohw_scroll_type_nav').css('color', use_type_color);
      var max_type_scroll = type_width - type_nav_width;
      
      
      $('#ohw_scroll_type_nav_right').mousedown(function(){
        start_scroll($('#ohw_type_nav'), 'right', max_type_scroll);  
      }).mouseup(function() {
        stop_scroll();
      });
      
      $('#ohw_scroll_type_nav_left').mousedown(function(){
        start_scroll($('#ohw_type_nav'), 'left', 0);  
      }).mouseup(function() {
        stop_scroll();
      });
      
      //setup mouseover functions for funky behaviors
      $('.ohw_scroll_type_nav').mouseenter(function(){
        scroll_hovered = true;
      }).mouseleave(function(){
        scroll_hovered = false;
      });
    } 
  }
  */
  //end scrolling functions
  
  function switch_type(){
    $('.ohw_type_data_active').removeClass('ohw_type_data_active');
    $('#ohw_' + active_topic + '_' + active_type).addClass('ohw_type_data_active');
    $('.ohw_type_link_active').addClass('ohw_type_links').removeClass('ohw_type_link_active');
    $('#ohw_type_' + active_type).addClass('ohw_type_link_active').removeClass('ohw_type_links');
    /**
    * slider functions disabled for sample
    if(is_slider == true){
      change_slider();
    }
    */
    //manually show/hide slider image, would normally be controlled by change_slider()
    if(active_type == 'news'){
      $('.ohw_slider_image:first').addClass('ohw_slider_image_active');
    } else {
      $('.ohw_slider_image_active').removeClass('ohw_slider_image_active');
    }
  }

  function switch_topic(){
    //alert(active_topic + ' - ' + active_type);
    //remove active class and revert to default links classes for topic/type nav
    $('.ohw_topic_link_active').addClass('ohw_topic_links').removeClass('ohw_topic_link_active');
    $('.ohw_type_link_active').addClass('ohw_type_links').removeClass('ohw_type_link_active');
    //add active class to active_topic link
    $('#ohw_topic_' + active_topic).addClass('ohw_topic_link_active').removeClass('ohw_topic_links');
    //fade out type navigation
    $('.ohw_type_list').fadeOut(0);
    //active_type_nav for loop through true/false per content
    var active_type_nav;
    //use_type is for first type to display
    var use_type = '';
    //reset type_nav_width and _num for showing scroll buttons on type nav
    type_nav_width = 0;
    type_nav_num = 0;
    //loop through object elements to find which types to display
    var topic_ref = OHW.widget.topic;
    for(active_type_nav in topic_ref[active_topic]){
      if(topic_ref[active_topic][active_type_nav] == true){
        $('#ohw_type_list_' + active_type_nav).fadeIn(200);
        if(use_type == ''){
          use_type = active_type_nav;
        }
        type_nav_width += $('#ohw_type_list_' + active_type_nav).width();
        type_nav_num++;
      }
    }
    active_type = use_type;
    //minor calculation for inline-block issues
    type_nav_width += (type_nav_num * 12);
    size_type_nav();
    switch_type();
  }
  
  $('.ohw_topic_links').click(function(){
    active_topic = $(this).attr('id').substring(10);
    switch_topic();       
  });
  
  $('.ohw_type_links').click(function() {                                          
    active_type = $(this).attr('id').substring(9);
    switch_type();
  });
                                      

  
  
  
  //show first topic/name for initialization based on variables set above
  /**
  * start the active topic (not needed for this)
  * 
  */
  //switch_topic();
  
  
  /**
  * Slider variables and functions
  * 
  */
  
  
  //check for featured slider and set variables if active
  
  /**
  * slider functions for activating the sliders
  *  
  var is_slider;             
  
  if(OHW.widget.use_slider.slider == true){
    is_slider = true;
    var active_slider;
    var active_slide_num = 1;
    var sliding;
    //setup move function
    function move_slider(slider_id){
      
      $('.ohw_slider_image').removeClass('ohw_slider_image_active');
      $('.ohw_slider_navigation_item').removeClass('ohw_slider_navigation_active');
      
      $(slider_id + ' .ohw_type_slider .ohw_slider_image_holder').find("[data-imagenum='" + active_slide_num + "']").addClass('ohw_slider_image_active');      
      $(slider_id + ' .ohw_type_slider' + ' .ohw_slider_navigation').find("[data-slidenum='" + active_slide_num + "']").addClass('ohw_slider_navigation_active');
      
    }
    
    //function to auto-move slider
    function run_slider(){
      if(active_slide_num == 3){
        active_slide_num = 1;
      } else { 
        active_slide_num++;
      }
      move_slider('#ohw_' + active_topic + '_' + active_type);
    }
    
    //start slider
    
    
    //pause slider
    function pause_slider(){
      window.clearInterval(sliding);
    }
    
    //restart slider
    function start_slider(){
      window.clearInterval(sliding);
      sliding = window.setInterval(function(){ run_slider(); }, 5000);
    }
    
    //change slider
    function change_slider(){
      window.clearInterval(sliding);
      active_slide_num = 1;
      move_slider('#ohw_' + active_topic + '_' + active_type);
      sliding = window.setInterval(function(){ run_slider(); }, 5000);   
    }
    
    
    
    //setup hover events..
    
    $('.ohw_slider_navigation_item').hover(
      function(){
        active_slide_num = $(this).data('slidenum');       
        move_slider('#ohw_' + active_topic + '_' + active_type);
        pause_slider(); 
      }, 
      function(){
        start_slider();
      }      
    ); 
    
    //initial start of slider
    change_slider();
    
  } else {
    is_slider = false;
  }
  
  
  */ 
  
  
  /**
  * cobranding placement of image if set  
  
  //co-brand image
  if(OHW.widget.co_branding.show_branding == true){
    $('#ohw_co_branding').html('<img src="' + OHW.widget.co_branding.brand_url + '" />');
  }
  */
  
  //set type slider links to header width - 225px (225px is image width)
  $('.ohw_slider_navigation').css('width', header_width - 225);
  
  //set ohw_type_data height for scrollbars (must be above .jScrollPane declarations or will render incorrectly)
  $('.ohw_type_data').css('height', use_height);
  
  //start scrollpane arrow scroller - should be last after ohw_type_data height has been set to use correct height for scrolling elements
  $('.scroll-pane-arrows').jScrollPane({
    showArrows: true,
    horizontalGutter: 10
  });
   
   
});