<!DOCTYPE html>
<html>
<head>

<link href="widget_core.css" rel="stylesheet">
<link href="widget_gray.css" rel="stylesheet">
<link href="widget_override.css" rel="stylesheet">

<link href="js/jquery.jscrollpane.css" rel="stylesheet" />
<link href="js/jquery.jscrollpane.lozenge.css" rel="stylesheet" />
                                                              


<script src="js/jquery.js"></script>
<script src="js/jquery.mousewheel.js"></script>
<script src="js/jquery.jscrollpane.js"></script>


<script src="ohw_new_widget.js"></script>    

</head>
<body> 

<!-- main wrapper - set layout width/height to this element -->  
<div id="ohw_widget_wrapper" style="width: 728px; height: 525px;">

<!-- main container set to 100% width to stretch full size of widget_wrapper -->
<div id="ohw_container" class="ohw_border_color ohw_main_background">

  <div id="ohw_header" class="ohw_border_color ohw_header_background">
    <div id="ohw_topic_nav_box">
      <ul id="ohw_topic_nav">
        <!-- main topic navigation. Can either load all then hide unused ones or use javascript to build only the needed ones -->
        <li id="ohw_topic_list_water-sports" class="ohw_topic_list"><a href="#" id="ohw_topic_water-sports" class="ohw_topic_links ohw_text_shadow_1 ohw_border_color">Boating &amp; Watersports</a></li>   
      </ul>
    </div>
  </div>
    
    
  <div id="ohw_nav" class="ohw_border_color ohw_type_header_background">
    <div id="ohw_type_nav_box">
      <ul id="ohw_type_nav">
        <!-- type navigation. Should display all types (news, jobs, stories, discussions, howto, reviews, jobs, videos) and fadeIn/Out or hide/show based on topic -->
        <li class="ohw_type_list" id="ohw_type_list_news"><a href="#" id="ohw_type_news" class="ohw_type_links ohw_text_shadow_1">News</a></li>                       
        <li class="ohw_type_list" id="ohw_type_list_jobs"><a href="#" id="ohw_type_jobs" class="ohw_type_links ohw_text_shadow_1">Jobs</a></li>
        <li class="ohw_type_list" id="ohw_type_list_videos"><a href="#" id="ohw_type_videos" class="ohw_type_links ohw_text_shadow_1">Videos</a></li>
      </ul>
    </div>
    <div id="ohw_type_share">
      <a href="#" class="ohw_type_links ohw_text_shadow_1" id="ohw_share_link">Share <img src="images/share_widget.png" border="0" align="absmiddle" /></a>
    </div>
  </div>
     
  <!-- absolutely positioned container to hold all type data elements -->
  <div id="ohw_type_holder">
  
    <!-- replicate this element with id to show which button clicked - ohw_type_data gets resized for the scroll-pane-arrows to load the elements to the proper height -->
    <div id="ohw_water-sports_news" class="ohw_type_data ohw_type_data_active scroll-pane-arrows"> 
  
      <!-- slider format -->
      <div class="ohw_type_slider">
        <div class="ohw_slider_image_holder ohw_border_color">
          <img src="images/fish.jpg" data-imagenum="1" class="ohw_slider_image ohw_slider_image_active" />
          <img src="images/shooter.jpg" data-imagenum="2" class="ohw_slider_image" />
          <img src="images/camera.jpg" data-imagenum="3" class="ohw_slider_image" />
        </div>
        <div class="ohw_slider_navigation">
          <a href="#" class="ohw_slider_navigation_item ohw_border_color ohw_slider_navigation_active" data-slidenum="1">
            Featured News Title For The Featured type Link For Slider To Wrap Or Overflow...
          </a>
          <a href="#" class="ohw_slider_navigation_item ohw_border_color" data-slidenum="2">
            Featured type Link For Slider
          </a>
          <a href="#" class="ohw_slider_navigation_item ohw_border_color" data-slidenum="3">
            Featured type Link For Slider
          </a>
        </div>
      </div>
      <!-- end slider -->
      
      
      <!-- replicate this element for each article for the main types (news, stories, opinions, how-to, discussions, reviews --> 
      <div class="ohw_type_item">
        <p><span class="ohw_type_title ohw_text_shadow2">Boating News Title</span> 
          <span class="ohw_type_date">February 29, 2012</span>
        </p>
        <p class="ohw_type_info">
          <img src="images/content_image.png" class="ohw_type_image ohw_image_border" align="left" />
          Lorem ipsum dolor sit amet, consectetur adipiscing elit. Maecenas id risus augue, eu euismod purus. Quisque iaculis risus ac tellus malesuada sed bibendum quam fringilla. Nulla scelerisque, libero id suscipit ultrices, mi nulla dignissim risus, ut imperdiet nunc nunc a diam. Nunc enim ipsum, eleifend non bibendum et, dictum in velit. Cras in risus neque, id volutpat risus. Duis eget velit nec purus accumsan facilisis. 
        </p>
        <p class="ohw_right"><a href="#" class="ohw_more_news ohw_read_more">Read More</a></p>    
        <!-- clearbox ensures elements are cleared before next element -->
        <div class="clearbox"></div>
      </div><!-- end individual article element -->
        
    </div><!-- end topic/type holder (ohw_type_data) -->
    
    
    <!-- jobs specific container element -->
    <div id="ohw_water-sports_jobs" class="ohw_type_data scroll-pane-arrows">
    
      <!-- individual jobs element -->
      <div class="ohw_type_item">
        <p><span class="ohw_type_title ohw_text_shadow2">Jobs Title</span></p>
        <p class="ohw_type_info">Jobs Company 
          <span class="ohw_right ohw_jobs_link"><a href="#" class="ohw_more_jobs ohw_read_more">Read More</a></span>
          <br />Location
        </p>
        <div class="clearbox"></div>
      </div><!-- end jobs elements -->
      
    </div><!-- end jobs specific container element -->
    
    <!-- video specific container element -->
    <div id="ohw_water-sports_videos" class="ohw_type_data scroll-pane-arrows">
      
      <!-- individual video elements -->
      <div class="ohw_video_item">
        <p><a href="#" class="ohw_play_video"><img src="images/video_image.jpg" class="ohw_video_icon" /></a></p>
        <p class="ohw_type_info ohw_text_shadow2">Water Sports Video Title
          <br />February 29, 2012
          <br /><a href="#" class="ohw_video_play"><span class="ohw_video_arrow"></span></a>
        </p>
      </div><!-- end individual video elements -->
          
    </div><!-- end video specific container element -->
   
  </div><!-- end ohw_type_holder container for all data elements -->



  <div id="ohw_footer" class="ohw_border_color ohw_footer_background">
    <div id="ohw_co_branding">
    
    </div>
    <div id="ohw_powered_by">
      <img src="images/powered_by_outdoorhub.png">
    </div>    
  </div>
  
</div><!-- end ohw_container -->

</div><!-- end ohw_widget_wrapper -->
</body>
</html>